## ezquake 2.2%2Bgit20150324

=== debian/changelog ===
ezquake (2.2+git20150324-1) unstable; urgency=low

  * Initial release.

 -- Michael Gilbert <mgilbert@debian.org>  Wed, 13 Jul 2016 02:44:00 +0000
