=== debian/control ===
Source: ezquake
Section: games
Priority: optional
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders: Michael Gilbert <mgilbert@debian.org>
Build-Depends:
 debhelper (>= 9),
 zlib1g-dev,
 libpng-dev,
 libsdl2-dev,
 libjpeg-dev,
 liblzma-dev,
 libpcre3-dev,
 libexpat-dev,
 libvorbis-dev,
 libjansson-dev,
 libcurl4-gnutls-dev,
Standards-Version: 3.9.6
Homepage: http://ezquake.sourceforge.net
Vcs-Git: git://anonscm.debian.org/pkg-games/ezquake.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-games/ezquake.git

Package: ezquake
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Suggests:
 quake-data | game-data-packager,
Provides:
 quake-engine,
Description: modern QuakeWorld client
 ezQuake is a modern QuakeWorld engine.  It adds many useful features like
 modern graphics, QuakeTV support, mp3 playback, multi-monitor support, a
 built-in server browser, and many features serving the needs of
 competitive Quake gamers.
 .
 QuakeWorld itelf is a variant of the Quake engine designed specifically
 for online gameplay.
 .
 This package contains no data files. To use it, you will need either the
 commercial Quake 1 data, the shareware data (game-data-packager can be
 helpful), or free game data files such as OpenQuartz.
