=== debian/rules ===
#!/usr/bin/make -f

export DH_VERBOSE=1

export MAKEFLAGS=V=1

export DEB_CFLAGS_MAINT_APPEND=$(shell dpkg-buildflags --get CPPFLAGS)

export DEB_LDFLAGS_MAINT_APPEND=-pthread

export DEB_BUILD_MAINT_OPTIONS=hardening=+all

%:
	dh $@ --parallel
