## ezquake 3.2.3

=== debian/changelog ===
ezquake (3.2.3-1) unstable; urgency=medium

  * New upstream release.
    - Limits cl_rollangle to 5 in competitive rulesets.

 -- Michael Gilbert <mgilbert@debian.org>  Tue, 16 Feb 2021 23:08:07 +0000

ezquake (3.2.2-3) unstable; urgency=medium

  * Remove MP3 support from the package description (closes: #981727).

 -- Michael Gilbert <mgilbert@debian.org>  Mon, 08 Feb 2021 01:45:13 +0000

ezquake (3.2.2-2) unstable; urgency=medium

  * Add minizip to the build dependencies.

 -- Michael Gilbert <mgilbert@debian.org>  Tue, 26 Jan 2021 04:58:14 +0000

ezquake (3.2.2-1) unstable; urgency=medium

  * New upstream release (closes: #973940).
    - Support for building with gcc 10 (closes: #957187).
  * Remove teamplay.cfg from the upstream tarball (closes: #884085).
  * Update to debhelper 11.
  * Add an upstream watch file.
  * Build using meson and ninja.

 -- Michael Gilbert <mgilbert@debian.org>  Tue, 26 Jan 2021 04:30:50 +0000
