=== debian/control ===
--- 
+++ 
@@ -4,7 +4,9 @@
 Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
 Uploaders: Michael Gilbert <mgilbert@debian.org>
 Build-Depends:
- debhelper (>= 9),
+ debhelper (>= 11),
+ meson,
+ ninja-build,
  zlib1g-dev,
  libpng-dev,
  libsdl2-dev,
@@ -14,6 +16,8 @@
  libexpat-dev,
  libvorbis-dev,
  libjansson-dev,
+ libminizip-dev,
+ libspeexdsp-dev,
  libcurl4-gnutls-dev,
 Standards-Version: 3.9.6
 Homepage: http://ezquake.sourceforge.net
@@ -25,15 +29,14 @@
 Depends:
  ${misc:Depends},
  ${shlibs:Depends},
-Suggests:
+Recommends:
  quake-data | game-data-packager,
 Provides:
  quake-engine,
 Description: modern QuakeWorld client
  ezQuake is a modern QuakeWorld engine.  It adds many useful features like
- modern graphics, QuakeTV support, mp3 playback, multi-monitor support, a
- built-in server browser, and many features serving the needs of
- competitive Quake gamers.
+ modern graphics, QuakeTV support, multi-monitor support, a built-in server
+ browser, and many features serving the nedes of competitive Quake gamers.
  .
  QuakeWorld itelf is a variant of the Quake engine designed specifically
  for online gameplay.
