## ezquake 3.6.1

=== debian/changelog ===
ezquake (3.6.1-1.1) unstable; urgency=high

  * Non-maintainer upload.
  * Minimal invasive RC bug fix NMU as maintainer isn't reachable
  * Make compile warnings non-fatal (Closes: #1030184)
  * Fix duplicate file globs in debian/copyright

 -- Lee Garrett <debian@rocketjump.eu>  Thu, 02 Feb 2023 13:18:24 +0100

ezquake (3.6.1-1) unstable; urgency=medium

  * New upstream release.
  * Fix compiler warnings.
  * Update to debhelper 13.
  * Update debian/copyright.
  * Update standards version to 4.6.2.

 -- Michael Gilbert <mgilbert@debian.org>  Sun, 22 Jan 2023 20:25:58 +0000
