=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
 Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
 Uploaders: Michael Gilbert <mgilbert@debian.org>
 Build-Depends:
- debhelper (>= 11),
+ debhelper-compat (= 13),
  meson,
  ninja-build,
  zlib1g-dev,
@@ -14,15 +14,16 @@
  liblzma-dev,
  libpcre3-dev,
  libexpat-dev,
+ libspeex-dev,
  libvorbis-dev,
  libjansson-dev,
  libminizip-dev,
+ libsndfile1-dev,
  libspeexdsp-dev,
  libcurl4-gnutls-dev,
-Standards-Version: 3.9.6
-Homepage: http://ezquake.sourceforge.net
-Vcs-Git: git://anonscm.debian.org/pkg-games/ezquake.git
-Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-games/ezquake.git
+Standards-Version: 4.6.2
+Rules-Requires-Root: no
+Homepage: http://ezquake.com
 
 Package: ezquake
 Architecture: any
