=== debian/changelog ===
ezquake (3.6.4-3build4) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 16:47:23 +1100

ezquake (3.6.4-3build3) noble; urgency=medium

  * No-change rebuild against libcurl3t64-gnutls

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sat, 16 Mar 2024 06:52:17 +0000

ezquake (3.6.4-3build2) noble; urgency=medium

  * No-change rebuild against libminizip1t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Wed, 13 Mar 2024 03:30:11 +0000

ezquake (3.6.4-3build1) noble; urgency=medium

  * No-change rebuild against libpng16-16t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Thu, 29 Feb 2024 06:27:35 +0000

ezquake (3.6.4-3) unstable; urgency=medium

  * Fix 32-bit pointer conversion warning.

 -- Michael Gilbert <mgilbert@debian.org>  Mon, 15 Jan 2024 04:26:53 +0000

ezquake (3.6.4-2) unstable; urgency=medium

  * Add a manpage.
  * Fix incorrect format string.
  * Fix pointer conversion warnings.
  * Translate keymap files to UTF-8.
  * Drop patches that are no longer relevant.
  * Include debian revision in the version string.

 -- Michael Gilbert <mgilbert@debian.org>  Sun, 14 Jan 2024 21:06:31 +0000

ezquake (3.6.4-1) unstable; urgency=medium

  * Team upload
  * Import project on Salsa
  * remove dependency on obsolete pcre3 library (Closes: #1000035)
  * catchup with new build system: meson has been
    replaced with a static Makefile
  * refresh patches

  [Bastian Germann]
  * Add new copyright

 -- Alexandre Detiste <tchet@debian.org>  Wed, 20 Dec 2023 02:51:08 +0100
