=== debian/control ===
--- 
+++ 
@@ -1,18 +1,17 @@
 Source: ezquake
 Section: games
 Priority: optional
-Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
 Uploaders: Michael Gilbert <mgilbert@debian.org>
 Build-Depends:
  debhelper-compat (= 13),
- meson,
- ninja-build,
  zlib1g-dev,
  libpng-dev,
  libsdl2-dev,
  libjpeg-dev,
  liblzma-dev,
- libpcre3-dev,
+ libpcre2-dev,
  libexpat-dev,
  libspeex-dev,
  libvorbis-dev,
@@ -23,7 +22,9 @@
  libcurl4-gnutls-dev,
 Standards-Version: 4.6.2
 Rules-Requires-Root: no
-Homepage: http://ezquake.com
+Homepage: https://ezquake.com
+Vcs-Git: https://salsa.debian.org/games-team/ezquake.git
+Vcs-Browser: https://salsa.debian.org/games-team/ezquake
 
 Package: ezquake
 Architecture: any
