=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/ezquake-$1\.tar\.gz/ \
  https://github.com/ezQuake/ezquake-source/tags .*/v?(\d\S+)\.tar\.gz
