=== debian/changelog ===
ezquake (3.6.6-1) unstable; urgency=medium

  * Update d/watch file
  * New upstream version 3.6.6 (Closes: #1089179, #1079531)
  * Bump SV to 4.7.2
  * Update BD
  * Improve d/scripts/ezquake
  * Remove scripts/convert-keymaps and install
  * Refresh d/patches
  * Remove for now -Werror in d/rules
  * Add d/patches/pcre2.patch (Closes: #1088891)
  * d/copyright: remove misc/keymaps/* statement
  * Clean up d/rules
  * d/rules: binary as moved.
  * d/control: remove quake-data dep and reformat (depputy).
  * Add a README.Debian.

 -- Patrice Duroux <patrice.duroux@gmail.com>  Sat, 05 Apr 2025 12:40:31 +0100
