=== debian/control ===
--- 
+++ 
@@ -1,30 +1,32 @@
 Source: ezquake
 Section: games
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
-Uploaders: Michael Gilbert <mgilbert@debian.org>
+Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
+Uploaders:
+ Michael Gilbert <mgilbert@debian.org>,
 Build-Depends:
  debhelper-compat (= 13),
- zlib1g-dev,
+ cmake,
+ libcurl4-gnutls-dev,
+ libexpat-dev,
+ libfreetype-dev,
+ libjansson-dev,
+ libjpeg-dev,
+ libminizip-dev,
+ libpcre2-dev,
  libpng-dev,
  libsdl2-dev,
- libjpeg-dev,
- liblzma-dev,
- libpcre2-dev,
- libexpat-dev,
+ libsndfile1-dev,
  libspeex-dev,
- libvorbis-dev,
- libjansson-dev,
- libminizip-dev,
- libsndfile1-dev,
  libspeexdsp-dev,
- libcurl4-gnutls-dev,
-Standards-Version: 4.6.2
+ pkgconf,
+ zlib1g-dev,
+Standards-Version: 4.7.2
 Rules-Requires-Root: no
 Homepage: https://ezquake.com
 Vcs-Git: https://salsa.debian.org/games-team/ezquake.git
 Vcs-Browser: https://salsa.debian.org/games-team/ezquake
+X-Style: black
 
 Package: ezquake
 Architecture: any
