=== debian/rules ===
#!/usr/bin/make -f

export DH_VERBOSE=1

export DEB_BUILD_DATE="$(shell dpkg-parsechangelog --show-field=date)"

export DEB_CFLAGS_MAINT_APPEND=$(shell dpkg-buildflags --get CPPFLAGS) -Wno-deprecated-declarations -Wno-misleading-indentation -Wno-format-truncation -Wno-unused-result -Wno-unused-function -DBUILD_DATE=\"$(DEB_BUILD_DATE)\"

export DEB_BUILD_MAINT_OPTIONS=hardening=+all

%:
	dh $@

override_dh_auto_install:
	mv obj-*/ezquake-* ezquake
	rm -rf obj-*
	dh_auto_install
