=== debian/watch ===
version=4
opts="downloadurlmangle=s/archive\/refs\/tags\/@ANY_VERSION@(@ARCHIVE_EXT@)/releases\/download\/$1\/ezquake-source-$1$2/" \
 https://github.com/QW-Group/ezquake-source/tags .*/@ANY_VERSION@@ARCHIVE_EXT@
