## ezquake 3.6.8

=== debian/changelog ===
ezquake (3.6.8-1) unstable; urgency=medium

  * d/watch: version 5
  * d/gbp.conf: added with pristine.
  * New upstream version 3.6.8
  * d/salsa-ci.yml: added
  * d/control: remove RRR: no (default)

 -- Patrice Duroux <patrice.duroux@gmail.com>  Mon, 29 Dec 2025 09:02:13 +0100
