=== debian/control ===
--- 
+++ 
@@ -4,6 +4,7 @@
 Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
 Uploaders:
  Michael Gilbert <mgilbert@debian.org>,
+ Patrice Duroux <patrice.duroux@gmail.com>,
 Build-Depends:
  debhelper-compat (= 13),
  cmake,
@@ -22,7 +23,6 @@
  pkgconf,
  zlib1g-dev,
 Standards-Version: 4.7.2
-Rules-Requires-Root: no
 Homepage: https://ezquake.com
 Vcs-Git: https://salsa.debian.org/games-team/ezquake.git
 Vcs-Browser: https://salsa.debian.org/games-team/ezquake
