=== debian/watch ===
Version: 5

Source: https://github.com/QW-Group/ezquake-source/tags
Matching-Pattern: .*/@ANY_VERSION@@ARCHIVE_EXT@
Download-Url-Mangle: s/archive\/refs\/tags\/@ANY_VERSION@(@ARCHIVE_EXT@)/releases\/download\/$1\/ezquake-source-$1$2/
